/*
 * tft.c
 *
 *  Created on: 20231214
 *      Author: lceda
 */
#include "tft.h"
#include "tft_init.h"
#include "tftfont.h"
#include "string.h"
/*
 * ˵ָɫ
 * xsta,ysta   ʼ
 *        xend,yend   ֹ
 *        color       Ҫɫ
 * ֵ
 */
void TFT_Fill(uint16_t xsta,uint16_t ysta,uint16_t xend,uint16_t yend,uint16_t color)
{
    uint16_t i=0,j=0;
    TFT_Address_Set(xsta,ysta,xend-1,yend-1);//ʾΧ
    for(i=ysta;i<yend;i++)
    {
        for(j=xsta;j<xend;j++)
        {
            TFT_WR_DATA(color);
        }
    }
}

/*
 * ˵ָλû
 *     x,y 
 *          color ɫ
 * ֵ
 */
void TFT_DrawPoint(uint16_t x,uint16_t y,uint16_t color)
{
    TFT_Address_Set(x,y,x,y);
    TFT_WR_DATA(color);
}


/*
 *  ˵
 *     x1,y1   ʼ
 *          x2,y2   ֹ
 *          color   ߵɫ
 *  ֵ  
*/
void TFT_DrawLine(uint16_t x1,uint16_t y1,uint16_t x2,uint16_t y2,uint16_t color)
{
    uint16_t t=0;
    int xerr=0,yerr=0,delta_x=0,delta_y=0,distance=0;
    int incx=0,incy=0,uRow=0,uCol=0;
    delta_x=x2-x1; //
    delta_y=y2-y1;
    uRow=x1;//
    uCol=y1;
    if(delta_x>0){
        incx=1;//õ
    }
    else if (delta_x==0){
        incx=0;//ֱ
    }
    else{
        incx=-1;
        delta_x=-delta_x;
    }
    if(delta_y>0){
        incy=1;
    }
    else if (delta_y==0){
        incy=0;//ˮƽ
    }
    else {
        incy=-1;delta_y=-delta_y;
    }
    if(delta_x>delta_y){
        distance=delta_x; //ѡȡ
    }
    else {
        distance=delta_y;
    }
    for(t=0;t<distance+1;t++)
    {
        TFT_DrawPoint(uRow,uCol,color);//
        xerr+=delta_x;
        yerr+=delta_y;
        if(xerr>distance){
            xerr-=distance;
            uRow+=incx;
        }
        if(yerr>distance){
            yerr-=distance;
            uCol+=incy;
        }
    }
}


/*
 * ˵
 *     x1,y1   ʼ
 *          x2,y2   ֹ
 *          color   εɫ
 * ֵ  
*/
void TFT_DrawRectangle(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2,uint16_t color)
{
    TFT_DrawLine(x1,y1,x2,y1,color);
    TFT_DrawLine(x1,y1,x1,y2,color);
    TFT_DrawLine(x1,y2,x2,y2,color);
    TFT_DrawLine(x2,y1,x2,y2,color);
}


/*
 *  ˵Բ
 *     x0,y0   Բ
 *          r       뾶
 *          color   Բɫ
 *  ֵ  
*/
void Draw_Circle(uint16_t x0,uint16_t y0,uint8_t r,uint16_t color)
{
    int a=0,b=0;
    a=0;b=r;
    while(a<=b)
    {
        TFT_DrawPoint(x0-b,y0-a,color);             //3
        TFT_DrawPoint(x0+b,y0-a,color);             //0
        TFT_DrawPoint(x0-a,y0+b,color);             //1
        TFT_DrawPoint(x0-a,y0-b,color);             //2
        TFT_DrawPoint(x0+b,y0+a,color);             //4
        TFT_DrawPoint(x0+a,y0-b,color);             //5
        TFT_DrawPoint(x0+a,y0+b,color);             //6
        TFT_DrawPoint(x0-b,y0+a,color);             //7
        a++;
        if((a*a+b*b)>(r*r))//жҪĵǷԶ
        {
            b--;
        }
    }
}

/*
 * ˵    ʾִ
 *     x,yʾ
 *          *s Ҫʾĺִ
 *          fc ֵɫ
 *          bc ֵıɫ
 *          sizey ֺ ѡ 16 24 32
 *          mode:  0ǵģʽ  1ģʽ
 * ֵ         
*/
void TFT_ShowChinese(uint16_t x,uint16_t y,uint8_t *s,uint16_t fc,uint16_t bc,uint8_t sizey,uint8_t mode)
{
    while(*s!=0)
    {
        if(sizey==12) TFT_ShowChinese12x12(x,y,s,fc,bc,sizey,mode);
        else if(sizey==16) TFT_ShowChinese16x16(x,y,s,fc,bc,sizey,mode);
        else if(sizey==24) TFT_ShowChinese24x24(x,y,s,fc,bc,sizey,mode);
        else if(sizey==32) TFT_ShowChinese32x32(x,y,s,fc,bc,sizey,mode);
        else return;
        s+=2;
        x+=sizey;
    }
}

/*
 * ˵ʾ12x12
 *     x,yʾ
 *          *s Ҫʾĺ
 *          fc ֵɫ
 *          bc ֵıɫ
 *          sizey ֺ
 *          mode:  0ǵģʽ  1ģʽ
 * ֵ  
*/
void TFT_ShowChinese12x12(uint16_t x,uint16_t y,uint8_t *s,uint16_t fc,uint16_t bc,uint8_t sizey,uint8_t mode)
{
    uint8_t i=0,j=0,m=0;
    uint16_t k=0;
    uint16_t HZnum=0;//Ŀ
    uint16_t TypefaceNum=0;//һַռֽڴС
    uint16_t x0=x;
    TypefaceNum=(sizey/8+((sizey%8)?1:0))*sizey;

    HZnum=sizeof(tfont12)/sizeof(typFNT_GB12);  //ͳƺĿ
    for(k=0;k<HZnum;k++)
    {
        if((tfont12[k].Index[0]==*(s))&&(tfont12[k].Index[1]==*(s+1)))
        {
            TFT_Address_Set(x,y,x+sizey-1,y+sizey-1);
            for(i=0;i<TypefaceNum;i++)
            {
                for(j=0;j<8;j++)
                {
                    if(!mode)//ǵӷʽ
                    {
                        if(tfont12[k].Msk[i]&(0x01<<j)){
                            TFT_WR_DATA(fc);
                        }
                        else{
                            TFT_WR_DATA(bc);
                        }
                        m++;
                        if(m%sizey==0)
                        {
                            m=0;
                            break;
                        }
                    }
                    else//ӷʽ
                    {
                        if(tfont12[k].Msk[i]&(0x01<<j)){
                            TFT_DrawPoint(x,y,fc);//һ
                        }
                        x++;
                        if((x-x0)==sizey)
                        {
                            x=x0;
                            y++;
                            break;
                        }
                    }
                }
            }
        }
        continue;  //ҵӦֿ˳ֹظȡģӰ
    }
}

/*
 * ˵ʾ16x16
 *     x,yʾ
 *          *s Ҫʾĺ
 *          fc ֵɫ
 *          bc ֵıɫ
 *          sizey ֺ
 *          mode:  0ǵģʽ  1ģʽ
 * ֵ  
*/
void TFT_ShowChinese16x16(uint16_t x,uint16_t y,uint8_t *s,uint16_t fc,uint16_t bc,uint8_t sizey,uint8_t mode)
{
    uint8_t i=0,j=0,m=0;
    uint16_t k=0;
    uint16_t HZnum=0;//Ŀ
    uint16_t TypefaceNum=0;//һַռֽڴС
    uint16_t x0=x;
    TypefaceNum=(sizey/8+((sizey%8)?1:0))*sizey;
    HZnum=sizeof(tfont16)/sizeof(typFNT_GB16);  //ͳƺĿ
    for(k=0;k<HZnum;k++)
    {
        if ((tfont16[k].Index[0]==*(s))&&(tfont16[k].Index[1]==*(s+1)))
        {
            TFT_Address_Set(x,y,x+sizey-1,y+sizey-1);
            for(i=0;i<TypefaceNum;i++)
            {
                for(j=0;j<8;j++)
                {
                    if(!mode)//ǵӷʽ
                    {
                        if(tfont16[k].Msk[i]&(0x01<<j)){
                            TFT_WR_DATA(fc);
                        }
                        else {
                            TFT_WR_DATA(bc);
                        }
                        m++;
                        if(m%sizey==0)
                        {
                            m=0;
                            break;
                        }
                    }
                    else//ӷʽ
                    {
                        if(tfont16[k].Msk[i]&(0x01<<j)){
                            TFT_DrawPoint(x,y,fc);//һ
                        }
                        x++;
                        if((x-x0)==sizey)
                        {
                            x=x0;
                            y++;
                            break;
                        }
                    }
                }
            }
        }
        continue;  //ҵӦֿ˳ֹظȡģӰ
    }
}


/*
 * ˵ʾ24x24
 *     x,yʾ
 *          *s Ҫʾĺ
 *          fc ֵɫ
 *          bc ֵıɫ
 *          sizey ֺ
 *          mode:  0ǵģʽ  1ģʽ
 * ֵ  
*/
void TFT_ShowChinese24x24(uint16_t x,uint16_t y,uint8_t *s,uint16_t fc,uint16_t bc,uint8_t sizey,uint8_t mode)
{
    uint8_t i=0,j=0,m=0;
    uint16_t k=0;
    uint16_t HZnum=0;//Ŀ
    uint16_t TypefaceNum=0;//һַռֽڴС
    uint16_t x0=x;
    TypefaceNum=(sizey/8+((sizey%8)?1:0))*sizey;
    HZnum=sizeof(tfont24)/sizeof(typFNT_GB24);  //ͳƺĿ
    for(k=0;k<HZnum;k++)
    {
        if ((tfont24[k].Index[0]==*(s))&&(tfont24[k].Index[1]==*(s+1)))
        {
            TFT_Address_Set(x,y,x+sizey-1,y+sizey-1);
            for(i=0;i<TypefaceNum;i++)
            {
                for(j=0;j<8;j++)
                {
                    if(!mode)//ǵӷʽ
                    {
                        if(tfont24[k].Msk[i]&(0x01<<j)){
                            TFT_WR_DATA(fc);
                        }
                        else{
                            TFT_WR_DATA(bc);
                        }
                        m++;
                        if(m%sizey==0)
                        {
                            m=0;
                            break;
                        }
                    }
                    else//ӷʽ
                    {
                        if(tfont24[k].Msk[i]&(0x01<<j)){
                            TFT_DrawPoint(x,y,fc);//һ
                        }
                        x++;
                        if((x-x0)==sizey)
                        {
                            x=x0;
                            y++;
                            break;
                        }
                    }
                }
            }
        }
        continue;  //ҵӦֿ˳ֹظȡģӰ
    }
}

/*
 * ˵ʾ32x32
 *     x,yʾ
 *          *s Ҫʾĺ
 *          fc ֵɫ
 *          bc ֵıɫ
 *          sizey ֺ
 *          mode:  0ǵģʽ  1ģʽ
 * ֵ  
*/
void TFT_ShowChinese32x32(uint16_t x,uint16_t y,uint8_t *s,uint16_t fc,uint16_t bc,uint8_t sizey,uint8_t mode)
{
    uint8_t i=0,j,m=0;
    uint16_t k=0;
    uint16_t HZnum=0;//Ŀ
    uint16_t TypefaceNum=0;//һַռֽڴС
    uint16_t x0=x;
    TypefaceNum=(sizey/8+((sizey%8)?1:0))*sizey;
    HZnum=sizeof(tfont32)/sizeof(typFNT_GB32);  //ͳƺĿ
    for(k=0;k<HZnum;k++)
    {
        if ((tfont32[k].Index[0]==*(s))&&(tfont32[k].Index[1]==*(s+1)))
        {
            TFT_Address_Set(x,y,x+sizey-1,y+sizey-1);
            for(i=0;i<TypefaceNum;i++)
            {
                for(j=0;j<8;j++)
                {
                    if(!mode)//ǵӷʽ
                    {
                        if(tfont32[k].Msk[i]&(0x01<<j)){
                            TFT_WR_DATA(fc);
                        }
                        else{
                            TFT_WR_DATA(bc);
                        }
                        m++;
                        if(m%sizey==0)
                        {
                            m=0;
                            break;
                        }
                    }
                    else//ӷʽ
                    {
                        if(tfont32[k].Msk[i]&(0x01<<j)){
                            TFT_DrawPoint(x,y,fc);//һ
                        }
                        x++;
                        if((x-x0)==sizey)
                        {
                            x=x0;
                            y++;
                            break;
                        }
                    }
                }
            }
        }
        continue;  //ҵӦֿ˳ֹظȡģӰ
    }
}


/*
 * ˵ʾַ
 *     x,yʾ
 *          num Ҫʾַ
 *          fc ֵɫ
 *          bc ֵıɫ
 *          sizey ֺ
 *          mode:  0ǵģʽ  1ģʽ
 * ֵ  
*/
void TFT_ShowChar(uint16_t x,uint16_t y,uint8_t num,uint16_t fc,uint16_t bc,uint8_t sizey,uint8_t mode)
{
    uint8_t temp=0,sizex=0,t=0,m=0;
    uint16_t i=0,TypefaceNum=0;//һַռֽڴС
    uint16_t x0=x;
    sizex=sizey/2;
    TypefaceNum=(sizex/8+((sizex%8)?1:0))*sizey;
    num=num-' ';    //õƫƺֵ
    TFT_Address_Set(x,y,x+sizex-1,y+sizey-1);  //ùλ
    for(i=0;i<TypefaceNum;i++)
    {
        if(sizey==12){
            temp=ascii_1206[num][i];              //6x12
        }
        else if(sizey==16){
            temp=ascii_1608[num][i];       //8x16
        }
        else if(sizey==24){
            temp=ascii_2412[num][i];       //12x24
        }
        else if(sizey==32){
            temp=ascii_3216[num][i];       //16x32
        }
        else {
            return;
        }
        for(t=0;t<8;t++)
        {
            if(!mode)//ǵģʽ
            {
                if(temp&(0x01<<t)){
                    TFT_WR_DATA(fc);
                }
                else{
                    TFT_WR_DATA(bc);
                }
                m++;
                if(m%sizex==0){
                    m=0;
                    break;
                }
            }
            else//ģʽ
            {
                if(temp&(0x01<<t)){
                    TFT_DrawPoint(x,y,fc);//һ
                }
                x++;
                if((x-x0)==sizex)
                {
                    x=x0;
                    y++;
                    break;
                }
            }
        }
    }
}


/*
 * ˵ʾַ
 *     x,yʾ
 *          *p Ҫʾַ
 *          fc ֵɫ
 *          bc ֵıɫ
 *          sizey ֺ
 *          mode:  0ǵģʽ  1ģʽ
 * ֵ  
*/
void TFT_ShowString(uint16_t x,uint16_t y,const uint8_t *p,uint16_t fc,uint16_t bc,uint8_t sizey,uint8_t mode)
{
    while(*p!='\0')
    {
        TFT_ShowChar(x,y,*p,fc,bc,sizey,mode);
        x+=sizey/2;
        p++;
    }
}


/*
 * ˵ʾ
 * mnָ
 * ֵ  
*/
uint32_t mypow(uint8_t m,uint8_t n)
{
    uint32_t result=1;
    while(n--)result*=m;
    return result;
}


/*
 * ˵ʾ
 *     x,yʾ
 *          num Ҫʾ
 *          len Ҫʾλ
 *          fc ֵɫ
 *          bc ֵıɫ
 *          sizey ֺ
 * ֵ  
*/
void TFT_ShowIntNum(uint16_t x,uint16_t y,uint16_t num,uint8_t len,uint16_t fc,uint16_t bc,uint8_t sizey)
{
    uint8_t t=0,temp=0;
    uint8_t enshow=0;
    uint8_t sizex=sizey/2;
    for(t=0;t<len;t++)
    {
        temp=(num/mypow(10,len-t-1))%10;
        if(enshow==0&&t<(len-1))
        {
            if(temp==0)
            {
               TFT_ShowChar(x+t*sizex,y,' ',fc,bc,sizey,0);
               continue;
            }
            else {
                enshow=1;
            }

        }
        TFT_ShowChar(x+t*sizex,y,temp+48,fc,bc,sizey,0);
    }
}


/*
 * ˵ʾλС
 *     x,yʾ
 *          num ҪʾС
 *          len Ҫʾλ
 *          fc ֵɫ
 *          bc ֵıɫ
 *          sizey ֺ
 * ֵ  
*/
void TFT_ShowFloatNum1(uint16_t x,uint16_t y,float num,uint8_t len,uint16_t fc,uint16_t bc,uint8_t sizey)
{
    uint8_t t=0,temp=0,sizex=0;
    uint16_t num1=0;
    sizex=sizey/2;
    num1=num*100;
    for(t=0;t<len;t++)
    {
        temp=(num1/mypow(10,len-t-1))%10;
        if(t==(len-2))
        {
            TFT_ShowChar(x+(len-2)*sizex,y,'.',fc,bc,sizey,0);
            t++;
            len+=1;
        }
        TFT_ShowChar(x+t*sizex,y,temp+48,fc,bc,sizey,0);
    }
}


/******************************************************************************
      ˵ʾͼƬ
      ݣx,y
                length ͼƬ
                width  ͼƬ
                pic[]  ͼƬ
      ֵ  
******************************************************************************/
void TFT_ShowPicture(uint16_t x,uint16_t y,uint16_t length,uint16_t width,const uint8_t pic[])
{
    uint16_t i,j;
    uint32_t k=0;
    TFT_Address_Set(x,y,x+length-1,y+width-1);
    for(i=0;i<length;i++)
    {
        for(j=0;j<width;j++)
        {
            TFT_WR_DATA8(pic[k*2]);
            TFT_WR_DATA8(pic[k*2+1]);
            k++;
        }
    }
}

/*
 * ݣʾͨҳ
 * 
 * ֵ   
 */
void Show_General_Page(void)
{
    TFT_DrawLine(0,40,320,40,BLACK);
    TFT_DrawLine(0,80,320,80,BLACK);
    TFT_DrawLine(0,120,320,120,BLACK);
    TFT_DrawLine(0,160,320,160,BLACK);
    TFT_DrawLine(0,200,320,200,BLACK);
    TFT_DrawLine(0,200,320,200,BLACK);
    TFT_DrawLine(160,40,160,240,BLACK);
}

/*
 * ݣʾѹҳ
 * 
 * ֵ   
 */
void Show_Vlotage_Page(float value,uint8_t stallValue)
{
    char ShowData[64]={0};

    TFT_ShowChinese(96,4,"ѹģʽ",RED,WHITE,32,0);

    TFT_ShowChinese(48,44,"ѹ",RED,WHITE,32,0);
    TFT_ShowChar(112,44,':',RED,WHITE,32,0);
    sprintf(ShowData,"%2.4fV",value);
    TFT_ShowString(192,44,ShowData,RED,WHITE,32,0);
    memset(ShowData,0,64);

    TFT_ShowChinese(8,84,"Χ",RED,WHITE,32,0);
    TFT_ShowChar(136,84,':',RED,WHITE,32,0);
    switch(stallValue)
    {
    case 0:
        sprintf(ShowData,"0~3.3V");
        TFT_ShowString(192,84,ShowData,RED,WHITE,32,0);
        memset(ShowData,0,64);
        break;
    case 1:
        sprintf(ShowData,"3.3~24V");
        TFT_ShowString(192,84,ShowData,RED,WHITE,32,0);
        memset(ShowData,0,64);
        break;
    case 2:
        sprintf(ShowData,"24~220V");
        TFT_ShowString(192,84,ShowData,RED,WHITE,32,0);
        memset(ShowData,0,64);
        break;
    default:
        break;
    }

    TFT_ShowChinese(48,124,"",RED,WHITE,32,0);
    TFT_ShowChar(112,124,':',RED,WHITE,32,0);

    TFT_ShowChinese(48,164,"",RED,WHITE,32,0);
    TFT_ShowChar(112,164,':',RED,WHITE,32,0);

    TFT_ShowChinese(8,204,"ص",RED,WHITE,32,0);
    TFT_ShowChar(136,204,':',RED,WHITE,32,0);

}

/*
 * ݣʾҳ
 * 
 * ֵ   
 */
void Show_Current_Page(float value,uint8_t stallValue)
{
    char ShowData[64]={0};

    TFT_ShowChinese(96,0,"ģʽ",RED,WHITE,32,0);

    TFT_ShowChinese(48,44,"",RED,WHITE,32,0);
    TFT_ShowChar(112,44,':',RED,WHITE,32,0);
    sprintf(ShowData,"%.2fmA  ",value);
    TFT_ShowString(192,44,ShowData,RED,WHITE,32,0);
    memset(ShowData,0,64);

    TFT_ShowChinese(8,84,"Χ",RED,WHITE,32,0);
    TFT_ShowChar(136,84,':',RED,WHITE,32,0);
    switch(stallValue)
    {
    case 0:
        sprintf(ShowData,"0~300mA");
        TFT_ShowString(192,84,ShowData,RED,WHITE,32,0);
        memset(ShowData,0,64);
        break;
    case 1:
        sprintf(ShowData,"3.3~24V");
        TFT_ShowString(192,84,ShowData,RED,WHITE,32,0);
        memset(ShowData,0,64);
        break;
    default:
        break;
    }

    TFT_ShowChinese(48,124,"",RED,WHITE,32,0);
    TFT_ShowChar(112,124,':',RED,WHITE,32,0);

    TFT_ShowChinese(48,164,"",RED,WHITE,32,0);
    TFT_ShowChar(112,164,':',RED,WHITE,32,0);

    TFT_ShowChinese(8,204,"ص",RED,WHITE,32,0);
    TFT_ShowChar(136,204,':',RED,WHITE,32,0);
}

/*
 * ݣʾҳ
 * 
 * ֵ   
 */
void Show_Resistance_Page(float value,uint8_t stallValue)
{
    char ShowData[64]={0};

    TFT_ShowChinese(96,0,"ģʽ",RED,WHITE,32,0);

    TFT_ShowChinese(48,44,"",RED,WHITE,32,0);
    TFT_ShowChar(112,44,':',RED,WHITE,32,0);
    sprintf(ShowData,"%.1fK",value);
    TFT_ShowString(192,44,ShowData,RED,WHITE,32,0);
    memset(ShowData,0,64);

    TFT_ShowChinese(8,84,"Χ",RED,WHITE,32,0);
    TFT_ShowChar(136,84,':',RED,WHITE,32,0);
    switch(stallValue)
    {
    case 0:
        sprintf(ShowData,"0~1K");
        TFT_ShowString(192,84,ShowData,RED,WHITE,32,0);
        memset(ShowData,0,64);
        break;
    case 1:
        sprintf(ShowData,"1K~10K");
        TFT_ShowString(192,84,ShowData,RED,WHITE,32,0);
        memset(ShowData,0,64);
        break;
    case 2:
        sprintf(ShowData,"10K~100K");
        TFT_ShowString(192,84,ShowData,RED,WHITE,32,0);
        memset(ShowData,0,64);
        break;
    case 3:
        sprintf(ShowData,"100K~1MR");
        TFT_ShowString(192,84,ShowData,RED,WHITE,32,0);
        memset(ShowData,0,64);
        break;
    default:
        break;
    }

    TFT_ShowChinese(48,124,"",RED,WHITE,32,0);
    TFT_ShowChar(112,124,':',RED,WHITE,32,0);

    TFT_ShowChinese(48,164,"",RED,WHITE,32,0);
    TFT_ShowChar(112,164,':',RED,WHITE,32,0);

    TFT_ShowChinese(8,204,"ص",RED,WHITE,32,0);
    TFT_ShowChar(136,204,':',RED,WHITE,32,0);
}
